######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function mlh_init()
# returning the initial find group filter string.
######################################################################
# This function serves two purposes.
# It is called only once upon program invocation, so you may use
# it as a place to run initialization routines.
# It requires a return value of the default select group.
# examples of return values:
#   return "1=1" (select all rows)
#   return "1=0" (select no rows)
#   return "customer_num is not null" (select non-null customer_num's)
#   return "posted = \"N\"" (select only unposted documents)
#
    # Trap fatal errors
    whenever error call error_handler

    return "1=1"
end function
# mlh_init()

######################################################################
function mlh_clear()
######################################################################
#
    initialize p_xcntrc.* to null
    initialize q_xcntrc.* to null
    initialize m_xcntrc.* to null
end function
# mlh_clear

######################################################################
function mlh_construct()
# returning criteria
######################################################################
#
    construct scratch
      on
        stxcntrc.curr_asset, stxcntrc.fixed_asset, stxcntrc.curr_liab,
        stxcntrc.long_term_liab, stxcntrc.capital, stxcntrc.income,
        stxcntrc.cost_goods, stxcntrc.expense
      from
        s_cntrc.curr_asset, s_cntrc.fixed_asset, s_cntrc.curr_liab,
        s_cntrc.long_term_liab, s_cntrc.capital, s_cntrc.income,
        s_cntrc.cost_goods, s_cntrc.expense
    return scratch[1,512]
end function
# mlh_construct

######################################################################
function mlh_cursor()
######################################################################
# This function defines the table, filter, and ordering portions of
# the select statement used to build the FourGen scroller.
#
    call put_vararg("stxcntrc")
    call put_vararg("")
    call put_vararg("")
end function
# mlh_cursor()

