########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_actrng.4gs/screen1.trg  1.3  Delta: 2/20/91
########################################################################

defaults
input 1
    after_field curr_asset
        if p_xcntrc.curr_asset < 1000 or
           p_xcntrc.curr_asset > 9999 or
           p_xcntrc.curr_asset is null 
        then 
            let p_xcntrc.curr_asset = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "curr_asset"
            return
        end if
        if cash_warning(p_xcntrc.curr_asset)
        then
            call fg_err(2) # Checking Accounts Out Of Range
            let nxt_fld = "curr_asset"
            return
        end if;

    after_field fixed_asset
        if p_xcntrc.fixed_asset < 1000 or
           p_xcntrc.fixed_asset > 9999 or
           p_xcntrc.fixed_asset is null 
        then 
            let p_xcntrc.fixed_asset = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "fixed_asset"
            return
        end if;

    after_field curr_liab
        if p_xcntrc.curr_liab < 1000 or
           p_xcntrc.curr_liab > 9999 or
           p_xcntrc.curr_liab is null 
        then 
            let p_xcntrc.curr_liab = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "curr_liab"
            return
        end if;

    after_field long_term_liab
        if p_xcntrc.long_term_liab < 1000 or
           p_xcntrc.long_term_liab > 9999 or
           p_xcntrc.long_term_liab is null 
        then 
            let p_xcntrc.long_term_liab = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "long_term_liab"
            return
        end if;

    after_field capital
        if p_xcntrc.capital < 1000 or
           p_xcntrc.capital > 9999 or
           p_xcntrc.capital is null 
        then 
            let p_xcntrc.capital = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "capital"
            return
        end if;

    after_field income
        if p_xcntrc.income < 1000 or
           p_xcntrc.income > 9999 or
           p_xcntrc.income is null 
        then 
            let p_xcntrc.income = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "income"
            return
        end if;

    after_field cost_goods
        if p_xcntrc.cost_goods < 1000 or
           p_xcntrc.cost_goods > 9999 or
           p_xcntrc.cost_goods is null 
        then 
            let p_xcntrc.cost_goods = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "cost_goods"
            return
        end if;

    after_field expense
        if p_xcntrc.expense < 1000 or
           p_xcntrc.expense > 9999 or
           p_xcntrc.expense is null 
        then 
            let p_xcntrc.expense = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "expense"
            return
        end if;

    after_input
        if mustfill(p_xcntrc.curr_asset,"Current Asset")
          then let nxt_fld = "curr_asset" return end if
        if mustfill(p_xcntrc.fixed_asset,"Fixed Asset")
          then let nxt_fld = "fixed_asset" return end if
        if mustfill(p_xcntrc.curr_liab,"Current Liability")
          then let nxt_fld = "curr_liab" return end if
        if mustfill(p_xcntrc.long_term_liab,"Long Term Liability")
          then let nxt_fld = "long_term_liab" return end if
        if mustfill(p_xcntrc.capital,"Capital")
          then let nxt_fld = "capital" return end if
        if mustfill(p_xcntrc.income,"Income")
          then let nxt_fld = "income" return end if
        if mustfill(p_xcntrc.cost_goods,"Cost of Goods")
          then let nxt_fld = "cost_goods" return end if
        if mustfill(p_xcntrc.expense,"Expense")
          then let nxt_fld = "expense" return end if

        if nxt_fld is null then call chk_range() end if;

    at_eof
#######################################################################
function chk_range()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement
#   to make sure the account ranges are in ascending order.
#
    if
      p_xcntrc.curr_asset < p_xcntrc.fixed_asset and
      p_xcntrc.fixed_asset < p_xcntrc.curr_liab and
      p_xcntrc.curr_liab < p_xcntrc.long_term_liab and
      p_xcntrc.long_term_liab < p_xcntrc.capital and
      p_xcntrc.capital < p_xcntrc.income and
      p_xcntrc.income < p_xcntrc.cost_goods and
      p_xcntrc.cost_goods < p_xcntrc.expense
    then
        # accounts are properly ordered
    else
        call fg_err(1) # Account ranges must be ascending
        let nxt_fld = "curr_asset"
    end if
end function
# chk_range()

#######################################################################
function ok_add()
# returning true/false based upon ok/not_ok to add
#######################################################################
#
    call fg_err(32) #This function has been disabled 
    return false
end function
# ok_add()

#######################################################################
function ok_find()
# returning true/false based upon ok/not_ok to find
#######################################################################
#
    call fg_err(32) #This function has been disabled 
    return false
end function
# ok_find()

#######################################################################
function ok_delete()
# returning true/false based upon ok/not_ok to delete
#######################################################################
#
    call fg_err(32) #This function has been disabled 
    return false
end function
# ok_delete()

######################################################################
function cash_warning(new_acct_no)
# returns true/false depending on whether a cash account exists
######################################################################
#  this function is called when the user attempts to change the
#  current asset account range if it will exclude the cash account
#  setup previously in the i_cashe program.  this is necessary due to
#  the fact that no updating is allowed to the i_cashe records.

    define
          new_acct_no like stxckrgr.acct_no,
          p_count integer

    select count(*) into p_count from stxckrgr
       where stxckrgr.acct_no < new_acct_no

    # no checking accounts setup that conflict with range change
    if p_count < 1 then return false end if

    # otherwise return true, at least one checking account exists
    return true

end function
# cash_warning
        ;
