######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function brw_hook(ring_rowid, ring_cursor, ring_total)
# returning true, ring_rowid, ring_cursor, ring_total
######################################################################
#  This is the hook for ring_menu into the browser.  If this hook
#  is not present, then the browser functions are not compiled into
#  the generated code.  This hook tells the linker to load all of the
#  ring_scroll utilities from the ring_lib library.  The true return
#  status tells ring_menu (at run-time) to use this browser versus the
#  default browse menu.
#
    define
        ring_rowid  integer,        # rowid of current selection
        ring_cursor integer,        # absolute cursor address
        ring_total  integer         # number of elements in cursor

    # Trap fatal errors
    whenever error call error_handler

    call ring_scroll(ring_rowid, ring_cursor, ring_total)
      returning ring_rowid, ring_cursor, ring_total
    return true, ring_rowid, ring_cursor, ring_total
end function
# brw_hook()

######################################################################
function brw_close()
######################################################################
#  This function closes the browse window
#
    close window browse
end function
# brw_close()
