########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_xinfor.4gs/fg_funcs.4gl  1.1  Delta: 2/4/91
########################################################################

globals "globals.4gl"

#####################################################################
function t_main()
#####################################################################
# assign variables and set display of screen
#
    define
        quote char(1)

    let quote = "\""

    if p_src_type is null then call no_src_type() end if

    call xcontrol() returning m_xcntrc.*
    case p_src_type
        when "S"
            open form screen1 from "genj"
            let p_sel_filter = "stxinfor.src_type = ", quote, "S", quote
        when "D"
            open form screen1 from "dept"
            let p_sel_filter = "stxinfor.src_type = ", quote, "D", quote
        when "W"
            open form screen1 from "whse"
            let p_sel_filter = "stxinfor.src_type = ", quote, "W", quote
        when "P"
            open form screen1 from "prdc"
            let p_sel_filter = "stxinfor.src_type = ", quote, "P", quote
        when "L"
            open form screen1 from "slsm"
            let p_sel_filter = "stxinfor.src_type = ", quote, "L", quote
        when "T"
            open form screen1 from "taxc"
            let p_sel_filter = "stxinfor.src_type = ", quote, "T", quote
        when "C"
            open form screen1 from "comm"
            let p_sel_filter = "stxinfor.src_type = ", quote, "C", quote
        when "R"
            open form screen1 from "rsnc"
            let p_sel_filter = "stxinfor.src_type = ", quote, "R", quote
        when "N"
            open form screen1 from "prsn"
            let p_sel_filter = "stxinfor.src_type = ", quote, "N", quote
        when "I"
            open form screen1 from "disc"
            let p_sel_filter = "stxinfor.src_type = ", quote, "I", quote
        when "B"
            open form screen1 from "buyr"
            let p_sel_filter = "stxinfor.src_type = ", quote, "B", quote
        when "M"
            open form screen1 from "mthd"
            let p_sel_filter = "stxinfor.src_type = ", quote, "M", quote
        otherwise
            call no_src_type()
    end case

end function 
#t_main

######################################################################
function alt_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the alternate lookup function.  It is passed a table to
# lookup, and based on that, it looks up the key and fills any
# variables for that table.  The lookup function will produce the
# error if it is called with mustfind=true, and a notfound situation
# exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Trap fatal errors
    whenever error call error_handler

    case
      when tbl_name = "dept_look"
        select src_desc into p_xinfor.description
          from stxinfor where 
           stxinfor.src_type = "D" and
           stxinfor.src_key = p_xinfor.src_char_desc
        let stat = sqlca.sqlcode
      when tbl_name = "comm_look"
        select src_desc into p_xinfor.description
          from stxinfor where 
           stxinfor.src_type = "C" and
           stxinfor.src_key = p_xinfor.src_char_desc
        let stat = sqlca.sqlcode
    end case

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if

    # Return false if lookup failed
    if stat = notfound
      then return false
      else return true
    end if

end function
# alt_lookup

######################################################################
function no_src_type()
######################################################################
#  This function is called only if the source type (p_src_type) is
#  missing or invalid.  This should never happen, unless the program
#  is run from the command line with no arguments, or the programmer
#  called this function from the menu front end without any flags or
#  with an incorrect source type.  A list of correct source types can
#  be found in the "Info" file, located in this program's directory.

    define response char(1)  # key pressed in response

    open window src_win at 7,18 with 12 rows, 46 columns
       attribute(border, red, prompt line 12)

    display "   Missing Or Invalid Source Type Detected.   " at 1,1
       attribute(reverse)
    display "==============================================" at 2,1
    display " This message will only appear if the program " at 3,1
    display " is run from the command line with no arg-    " at 4,1
    display " uments or if the programmer called this pro- " at 5,1
    display " gram from the menu without any flags or with " at 6,1
    display " an incorrect Source Type flag.  A list of    " at 7,1
    display " the correct source types can be found in the " at 8,1
    display " 'Info' file, located in this program's       " at 9,1
    display " directory (i_xinfor).                        " at 10,1
    display "==============================================" at 11,1
    prompt  "               Press Any Key...              "
      for char response

    close window src_win
    exit program(0)

end function
# no_src_type

#####################################################################
function fg_help(hlp_num)
#####################################################################
# This is a shortcut into lib_help().  It parses progid to determine
# the hlp_mod and hlp_prog.
#
    define
        hlp_num     smallint,   # help number within the program
        hlp_mod     char(8),    # module name
        hlp_prog    char(8)     # program name within the module

    # Use the source key to determine help number
    case
      when p_src_type = "S" let hlp_num = 5  # general journal source input
      when p_src_type = "D" let hlp_num = 3  # department input
      when p_src_type = "W" let hlp_num = 10 # warehouse input
      when p_src_type = "P" let hlp_num = 6  # product code input
      when p_src_type = "L" let hlp_num = 8  # salesperson input
      when p_src_type = "T" let hlp_num = 12 # tax code input
      when p_src_type = "C" let hlp_num = 11 # commission code input
      when p_src_type = "R" let hlp_num = 9  # debit/credit reason code input
      when p_src_type = "I" let hlp_num = 7  # discount code input
      when p_src_type = "B" let hlp_num = 4  # buyer input
      when p_src_type = "M" let hlp_num = 2  # method of payment code
    otherwise
      let hlp_num = 1  # generic input
    end case

    # Parse the module and program name from progid
    call get_mod() returning hlp_mod, hlp_prog

    # Pass those onto lib_help()
    call lib_help(hlp_mod, hlp_prog, hlp_num)
end function
# fg_help()

######################################################################
function brw_open()
# returning num_rows
######################################################################
#  This function opens the browse window and tells the ring_menu
#  the number of rows there are on the screen to scroll through.
#
    case p_src_type
        when "S"
          open window browse at 5,15
              with form "brw_s"
              attribute (white, border)
        when "D"
          open window browse at 5,15
              with form "brw_d"
              attribute (white, border)
        when "W"
          open window browse at 5,12
              with form "brw_w"
              attribute (white, border)
        when "P"
          open window browse at 5,15
              with form "brw_p"
              attribute (white, border)
        when "L"
          open window browse at 5,12
              with form "brw_l"
              attribute (white, border)
        when "T"
          open window browse at 5,8
              with form "brw_t"
              attribute (white, border)
        when "C"
          open window browse at 5,12
              with form "brw_c"
              attribute (white, border)
        when "R"
          open window browse at 5,12
              with form "brw_r"
              attribute (white, border)
        when "N"
          open window browse at 5,12
              with form "brw_n"
              attribute (white, border)
        when "I"
          open window browse at 5,7 
              with form "brw_i"
              attribute (white, border)
        when "B"
          open window browse at 5,15
              with form "brw_b"
              attribute (white, border)
        when "M"
          open window browse at 5,14
              with form "brw_m"
              attribute (white, border)
        otherwise
    end case

    return 10
end function
# brw_open

######################################################################
function brw_display(line_no,highlight)
######################################################################
#  This function displays the header p_* variables into the correct
#  window line number (either highlighted, or not)
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    case p_src_type
        when "S"
          call display_2(line_no,highlight)
        when "D"
          call display_2(line_no,highlight)
        when "W"
          call display_4(line_no,highlight)
        when "P"
          call display_2(line_no,highlight)
        when "L"
          call display_3(line_no,highlight)
        when "T"
          call display_4a(line_no,highlight)
        when "C"
          call display_3a(line_no,highlight)
        when "R"
          call display_3a(line_no,highlight)
        when "N"
          call display_3a(line_no,highlight)
        when "I"
          call display_4(line_no,highlight)
        when "B"
          call display_2(line_no,highlight)
        when "M"
          call display_3(line_no,highlight)
        otherwise
    end case
end function
# brw_display

######################################################################
function display_2(line_no,highlight)
######################################################################
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    if highlight
    then
        display
            p_xinfor.src_key,
            p_xinfor.src_desc
          to
            xbrw[line_no].*
          attribute(reverse)
    else
        display
            p_xinfor.src_key,
            p_xinfor.src_desc
          to
            xbrw[line_no].*
          attribute(red)
    end if
end function
# display_2

######################################################################
function display_3(line_no,highlight)
######################################################################
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    if highlight
    then
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_char_desc
          to
            xbrw[line_no].*
          attribute(reverse)
    else
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_char_desc
          to
            xbrw[line_no].*
          attribute(red)
    end if
end function
# display_3

######################################################################
function display_3a(line_no,highlight)
######################################################################
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    if highlight
    then
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc
          to
            xbrw[line_no].*
          attribute(reverse)
    else
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc
          to
            xbrw[line_no].*
          attribute(red)
    end if
end function
# display_3a

######################################################################
function display_4(line_no,highlight)
######################################################################
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    if highlight
    then
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc,
            p_xinfor.src_char_desc
          to
            xbrw[line_no].*
          attribute(reverse)
    else
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc,
            p_xinfor.src_char_desc
          to
            xbrw[line_no].*
          attribute(red)
    end if
end function
# display_4

######################################################################
function display_4a(line_no,highlight)
######################################################################
#
    define
        line_no      smallint,        # window line number
        highlight    smallint         # boolean true/false

    if highlight
    then
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc,
            p_xinfor.src_acct_no
          to
            xbrw[line_no].*
          attribute(reverse)
    else
        display
            p_xinfor.src_key,
            p_xinfor.src_desc,
            p_xinfor.src_num_desc,
            p_xinfor.src_acct_no
          to
            xbrw[line_no].*
          attribute(red)
    end if
end function
# display_4a
