######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
main
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    clear screen
    defer interrupt
    let progid = "all.i_xinfor"
    call put_scrlib("version", "3.51.00")
    call put_scrlib("dbname", "standard")

    open window win1 at 2,3 with 22 rows, 76 columns
      attribute (border, blue)
    call init()

    clear window win1
    open window win2 at 2,3 with 22 rows, 76 columns
      attribute (white)
    open form screen1 from "allc"
    call get_src_type()
    call t_main()
    display form screen1
    call ring_header()
    exit program (0)
end main

######################################################################
function switchbox(funct)
######################################################################
# This is the switchbox function for version 3.0+ screens.
# It is used to pass flow control to the appropriate screen functions.
#
    define
        funct char(20)   # Function to pass on to the screen

    # Post the current function
    let scr_funct = funct

    # Pass flow control to the appropriate screen
    case
      when scr_id = "chrtz" call chrtz()
      when scr_id = "default" call lib_screen()
      when scr_id = "commz" call commz()  # commission code zoom
      when scr_id = "deptz" call deptz()  # department code zoom
      otherwise let scratch = "no screen"
    end case

    # Reset scr_funct upon return
    let scr_funct = ""

end function
# switchbox()

#####################################################################
function get_src_type()
# determines which screen to use
#####################################################################
# parse the command line for "-t X" where X is the source type.
# if the type is invalid or not found, screen will default to 2
# (all) and the browse filter will default to "1=1".  otherwise,
# the appropriate screen and filter will be chosen.
#
    define
        n smallint,
        src_type char(60)

    for n = 1 to num_args() - 1
        if arg_val(n) = "-t"
        then
            let src_type = arg_val(n+1)
            let p_src_type = upshift(src_type[1])
        end if
    end for
end function
# get_src_type
