######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/lib.4gs/paymtdz.4gl  1.4  Delta: 1/22/91
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    arr_cnt integer,      # Number of active elements in program array
    arr_max integer,      # Maximum available elements in program array
    p_paymtdz array[100] of record
        src_key like stxinfor.src_key,
        src_desc like stxinfor.src_desc,
        src_char_desc like stxinfor.src_char_desc
    end record

######################################################################
function paymtdz()
######################################################################
# This is a FourGen:Screen function switching mechanism.
# It's job is to route requests from the screen manager to the
# appropriate local function.
#
    # Trap fatal errors
    whenever error call error_handler

    case
      when scr_funct = "init" call Apaymtdz()
      when scr_funct = "read" call Rpaymtdz()
      when scr_funct = "display array" call Dpaymtdz()
      when scr_funct = "construct" call Qpaymtdz()
      when scr_funct = "close" call Zpaymtdz()
      when scr_funct = "build key" call Kpaymtdz()
      otherwise let scratch = "no function"
    end case
end function
# paymtdz()

######################################################################
function Apaymtdz()
######################################################################
# This is the zoom initialization function.
# It opens the window and displays the form.
#
    define
        y_pos smallint,  # window y position
        x_pos smallint   # window x position

    # Initialize variables
    call put_scrlib("module", "all")
    let arr_cnt = 0
    let arr_max = 100
    let sql_order  = "src_key"

    # Open the window and present the form
    call window_pos(5,19) returning y_pos, x_pos
    open window w_paymtdz at y_pos, x_pos with form "../../all.4gm/lib.4gs/paymtdz"
      attribute (white, border)

end function
# Apaymtdz()

######################################################################
function Kpaymtdz()
# returning tablename, key_field [,key_field]... in (vararg) scratch
######################################################################
# This function returns (in scratch) the name of the main table
# for this screen and the field(s) that build the unique key.
# This is used to determine the unique key for additional fields,
# notes, and other items that may key off this document.  The key
# field(s) must not exceed 30 characters total.
#
    call put_vararg("stxinfor")
    call put_vararg("src_key")
    call put_vararg(p_paymtdz[p_cur].src_key)
end function
# Kpaymtdz()

######################################################################
function Qpaymtdz()
######################################################################
# This function places the user into the 'Query by Forms' screen.
#
    construct scratch
      on
        stxinfor.src_key, stxinfor.src_desc, stxinfor.src_char_desc
      from
        s_paymtdz.src_key, s_paymtdz.src_desc, s_paymtdz.src_char_desc
end function
# Qpaymtdz()

######################################################################
function Rpaymtdz()
######################################################################
# This function builds and executes the SQL query.
#
    # Build the SQL string
    let scratch = "select ",
        "stxinfor.src_key, stxinfor.src_desc, ",
        "stxinfor.src_char_desc ",
        "from stxinfor where ",
        "stxinfor.src_type=\"M\" and stxinfor.src_char_desc=\"V\" and ",
        sql_filter clipped, sql_order clipped

    # Prepare the SQL string for execution
    prepare a_paymtdz from scratch
    declare c_paymtdz cursor for a_paymtdz

    # Read the elements into the program array
    let arr_cnt = 0
    foreach c_paymtdz into p_paymtdz[arr_cnt + 1].*
        let arr_cnt = arr_cnt + 1
        if arr_cnt = arr_max
        then
            call scr_error("overflow",arr_max)
            exit foreach
        end if
    end foreach
    close c_paymtdz

    # Return the number of elements
    let scratch = arr_cnt

end function
# Rpaymtdz()

######################################################################
function Dpaymtdz()
# returning true if the zoom function should exit.
######################################################################
# This function calls the display array.  If the user selects the row
# by pressing [ESC] or if they press [DEL] to cancel the operation,
# it informs the screen manager to exit this screen by setting
# int_flag to true.
# If they press [TAB], the screen manager places the user into the
# zoom ring menu.
#
    define
        exit_type char(5)  # Exit types: "quit" or "tab"

    # Setup for display array
    let exit_type = "quit"

    display array p_paymtdz to s_paymtdz.*
      attribute(red)

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (control-m, f35) let hotkey = 135 goto event
      on key (interrupt, f36) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_key("paymtdz")  # Map the key to the event
        case
          when scr_funct = "accept" exit display
          when scr_funct = "tab" or scr_funct = "btab"
            let exit_type = "tab"
            exit display
          when scr_funct = "cancel"
            let int_flag = true
            exit display
        end case

    end display

    # Return the exit type in scratch
    let scratch = exit_type

end function
# Dpaymtdz()

######################################################################
function Zpaymtdz()
######################################################################
# This function is called upon return from this screen
#
    # Close the window and make the data available
    close window w_paymtdz
    if p_cur = 0
      then let scratch = ""
      else let scratch = p_paymtdz[p_cur].src_key
    end if
end function
# Zpaymtdz()
