########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_gldetl.4gs/lowlevel.4gl  1.2  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    # Trap fatal errors
    whenever error call error_handler

    let rpt.amount = curs.amount
    let rpt.debit_credit = curs.debit_credit
#   let rpt.incr_with_crdt = curs.incr_with_crdt
#   let rpt.co_name = curs.co_name
    let rpt.acct_period = curs.acct_period
    let rpt.acct_year = curs.acct_year
    let rpt.acct_no = curs.acct_no
    let rpt.department = curs.department
#   let rpt.acct_desc = curs.acct_desc
    let rpt.orig_journal = curs.orig_journal
    let rpt.doc_no = curs.doc_no
    let rpt.doc_date = curs.doc_date
    let rpt.ref_code = curs.ref_code
    let rpt.doc_desc = curs.doc_desc
#   let rpt.db_amount = (MUST SUPPLY)
#   let rpt.cr_amount = (MUST SUPPLY)
    call al_chrtn(rpt.acct_no)
      returning rpt.acct_desc, rpt.incr_with_crdt

    if rpt.debit_credit = "C"
    then
         let rpt.cr_amount = curs.amount
         let rpt.db_amount = ""
    else
         let rpt.db_amount = curs.amount
         let rpt.cr_amount = ""
    end if

    # Send the line to the summary tables
    call gl_sumput(rpt.doc_no, rpt.acct_period, rpt.acct_year, 
      rpt.acct_no, rpt.department, rpt.amount, rpt.debit_credit)

    return
end function
# on_every_row()

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "acct_no" then
        # insert "before group of acct_no" code here
        return
    end if

    if group_key = "department" then
        # insert "before group of department" code here
        return
    end if

    if group_key = "orig_journal" then
        # insert "before group of orig_journal" code here
        return
    end if

    if group_key = "doc_date" then
        # insert "before group of doc_date" code here
        return
    end if

end function
# before_group()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "acct_no" then
        # insert "after group of acct_no" code here
        return
    end if

    if group_key = "department" then
        # insert "after group of department" code here
        return
    end if

    if group_key = "orig_journal" then
        # insert "after group of orig_journal" code here
        return
    end if

    if group_key = "doc_date" then
        # insert "after group of doc_date" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()

#######################################################################
function ll_transaction()
#######################################################################
#  this function is called for each item in the cursor after the
#  ll_prepare() function, and before the data is sent to the report.
#  it's function is to process a complete transaction.
#  a transaction is defined as a begin work/update database/rollback
#  or commit work sequence.
#  if the report doesn't update the database, or if your database doesn't
#  use transactions, then you can delete this function.
#
    return
end function
# ll_transaction()

