########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_gldetl.4gs/report.4gl  1.8  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            amount like stgactvd.amount,
            debit_credit like stgactvd.debit_credit,
            incr_with_crdt like stxchrtr.incr_with_crdt,
            co_name like stxcntrc.co_name,
            acct_period like stgtranr.acct_period,
            acct_year like stgtranr.acct_year,
            acct_no like stgactvd.acct_no,
            department like stgactvd.department,
            acct_desc like stxchrtr.acct_desc,
            orig_journal like stxtranr.orig_journal,
            doc_no like stxtranr.doc_no,
            doc_date like stxtranr.doc_date,
            ref_code like stxtranr.ref_code,
            doc_desc like stxtranr.doc_desc,
            db_amount like stgactvd.amount,
            cr_amount like stgactvd.amount,
            head1 char(30),
            head2 char(62)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.acct_no, rpt.department, rpt.doc_date, rpt.orig_journal, rpt.doc_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, today using "mm/dd/yy";
                let scratch = "G/L Activity Detail"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = rpt.head1
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = rpt.head2
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "Source",
                column   9, "Doc #",
                column  16, "Date",
                column  25, "Ref",
                column  33, "Description",
                column  59, "Debits",
                column  73, "Credits"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "G/L Activity Detail";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.department
            print
                column   1, rpt.acct_no using "######",
                column   5, "-",
                column   8, rpt.department,
                column  13, rpt.acct_desc

        on every row
            print
                column   1, rpt.orig_journal,
                column   9, rpt.doc_no using "<<<<<<",
                column  16, rpt.doc_date using "mm/dd/yy",
                column  25, rpt.ref_code,
                column  33, rpt.doc_desc[1,18],
                column  51, rpt.db_amount using "(((,(((,(((.&&)",
                column  66, rpt.cr_amount using "(((,(((,(((.&&)"

        after group of rpt.department
            need 3 lines
            print
                column  53, "-------------",
                column  68, "-------------"
            print
                column  11, "Total Activity for Account: ",
                column  39, rpt.acct_no using "######",
                column  43, "-",
                column  46, rpt.department,
                column  51, group sum(rpt.db_amount) using "(((,(((,(((.&&)",
                column  66, group sum(rpt.cr_amount) using "(((,(((,(((.&&)"
            print

        on last row
            need 4 lines
            print
                column   1, "----------------------------------- Tota",
                column  41, "l --------------------------------------"
            print
                column  59, "Debits",
                column  73, "Credits"
            print
                column  51, sum(rpt.db_amount) using "(((,(((,(((.&&)",
                column  66, sum(rpt.cr_amount) using "(((,(((,(((.&&)"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

            # Additional lines for the g/l summary report
            skip to top of page
            call gl_sumrpt()
            print file "sumrpt.out"

end report
# report1()
